<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FileSnap.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.persistence</a> &gt; <span class="el_source">FileSnap.java</span></div><h1>FileSnap.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.persistence;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.zip.Adler32;
import java.util.zip.CheckedInputStream;
import java.util.zip.CheckedOutputStream;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.server.DataTree;
import org.apache.zookeeper.server.util.SerializeUtils;

/**
 * This class implements the snapshot interface.
 * it is responsible for storing, serializing
 * and deserializing the right snapshot.
 * and provides access to the snapshots.
 */
public class FileSnap implements SnapShot {
    File snapDir;
<span class="fc" id="L53">    private volatile boolean close = false;</span>
    private static final int VERSION=2;
    private static final long dbId=-1;
<span class="fc" id="L56">    private static final Logger LOG = LoggerFactory.getLogger(FileSnap.class);</span>
<span class="fc" id="L57">    public final static int SNAP_MAGIC</span>
<span class="fc" id="L58">        = ByteBuffer.wrap(&quot;ZKSN&quot;.getBytes()).getInt();</span>
<span class="fc" id="L59">    public FileSnap(File snapDir) {</span>
<span class="fc" id="L60">        this.snapDir = snapDir;</span>
<span class="fc" id="L61">    }</span>

    /**
     * deserialize a data tree from the most recent snapshot
     * @return the zxid of the snapshot
     */ 
    public long deserialize(DataTree dt, Map&lt;Long, Integer&gt; sessions)
            throws IOException {
        // we run through 100 snapshots (not all of them)
        // if we cannot get it running within 100 snapshots
        // we should  give up
<span class="fc" id="L72">        List&lt;File&gt; snapList = findNValidSnapshots(100);</span>
<span class="fc bfc" id="L73" title="All 2 branches covered.">        if (snapList.size() == 0) {</span>
<span class="fc" id="L74">            return -1L;</span>
        }
<span class="fc" id="L76">        File snap = null;</span>
<span class="fc" id="L77">        boolean foundValid = false;</span>
<span class="fc bfc" id="L78" title="All 2 branches covered.">        for (int i = 0; i &lt; snapList.size(); i++) {</span>
<span class="fc" id="L79">            snap = snapList.get(i);</span>
<span class="fc" id="L80">            InputStream snapIS = null;</span>
<span class="fc" id="L81">            CheckedInputStream crcIn = null;</span>
            try {
<span class="fc" id="L83">                LOG.info(&quot;Reading snapshot &quot; + snap);</span>
<span class="fc" id="L84">                snapIS = new BufferedInputStream(new FileInputStream(snap));</span>
<span class="fc" id="L85">                crcIn = new CheckedInputStream(snapIS, new Adler32());</span>
<span class="fc" id="L86">                InputArchive ia = BinaryInputArchive.getArchive(crcIn);</span>
<span class="fc" id="L87">                deserialize(dt,sessions, ia);</span>
<span class="fc" id="L88">                long checkSum = crcIn.getChecksum().getValue();</span>
<span class="fc" id="L89">                long val = ia.readLong(&quot;val&quot;);</span>
<span class="pc bpc" id="L90" title="1 of 2 branches missed.">                if (val != checkSum) {</span>
<span class="nc" id="L91">                    throw new IOException(&quot;CRC corruption in snapshot :  &quot; + snap);</span>
                }
<span class="fc" id="L93">                foundValid = true;</span>
<span class="fc" id="L94">                break;</span>
<span class="fc" id="L95">            } catch(IOException e) {</span>
<span class="fc" id="L96">                LOG.warn(&quot;problem reading snap file &quot; + snap, e);</span>
<span class="fc" id="L97">            } finally {</span>
<span class="nc" id="L98">                if (snapIS != null) </span>
<span class="pc" id="L99">                    snapIS.close();</span>
<span class="pc bpc" id="L100" title="4 of 6 branches missed.">                if (crcIn != null) </span>
<span class="pc bpc" id="L101" title="3 of 4 branches missed.">                    crcIn.close();</span>
<span class="fc" id="L102">            } </span>
        }
<span class="fc bfc" id="L104" title="All 2 branches covered.">        if (!foundValid) {</span>
<span class="fc" id="L105">            throw new IOException(&quot;Not able to find valid snapshots in &quot; + snapDir);</span>
        }
<span class="fc" id="L107">        dt.lastProcessedZxid = Util.getZxidFromName(snap.getName(), &quot;snapshot&quot;);</span>
<span class="pc bpc" id="L108" title="1 of 2 branches missed.">        return dt.lastProcessedZxid;</span>
    }

    /**
     * deserialize the datatree from an inputarchive
     * @param dt the datatree to be serialized into
     * @param sessions the sessions to be filled up
     * @param ia the input archive to restore from
     * @throws IOException
     */
    public void deserialize(DataTree dt, Map&lt;Long, Integer&gt; sessions,
            InputArchive ia) throws IOException {
<span class="fc" id="L120">        FileHeader header = new FileHeader();</span>
<span class="fc" id="L121">        header.deserialize(ia, &quot;fileheader&quot;);</span>
<span class="fc bfc" id="L122" title="All 2 branches covered.">        if (header.getMagic() != SNAP_MAGIC) {</span>
<span class="fc" id="L123">            throw new IOException(&quot;mismatching magic headers &quot;</span>
<span class="fc" id="L124">                    + header.getMagic() + </span>
                    &quot; !=  &quot; + FileSnap.SNAP_MAGIC);
        }
<span class="fc" id="L127">        SerializeUtils.deserializeSnapshot(dt,ia,sessions);</span>
<span class="fc" id="L128">    }</span>

    /**
     * find the most recent snapshot in the database.
     * @return the file containing the most recent snapshot
     */
    public File findMostRecentSnapshot() throws IOException {
<span class="fc" id="L135">        List&lt;File&gt; files = findNValidSnapshots(1);</span>
<span class="pc bpc" id="L136" title="1 of 2 branches missed.">        if (files.size() == 0) {</span>
<span class="nc" id="L137">            return null;</span>
        }
<span class="fc" id="L139">        return files.get(0);</span>
    }
    
    /**
     * find the last (maybe) valid n snapshots. this does some 
     * minor checks on the validity of the snapshots. It just
     * checks for / at the end of the snapshot. This does
     * not mean that the snapshot is truly valid but is
     * valid with a high probability. also, the most recent 
     * will be first on the list. 
     * @param n the number of most recent snapshots
     * @return the last n snapshots (the number might be
     * less than n in case enough snapshots are not available).
     * @throws IOException
     */
    private List&lt;File&gt; findNValidSnapshots(int n) throws IOException {
<span class="fc" id="L155">        List&lt;File&gt; files = Util.sortDataDir(snapDir.listFiles(),&quot;snapshot&quot;, false);</span>
<span class="fc" id="L156">        int count = 0;</span>
<span class="fc" id="L157">        List&lt;File&gt; list = new ArrayList&lt;File&gt;();</span>
<span class="fc bfc" id="L158" title="All 2 branches covered.">        for (File f : files) {</span>
            // we should catch the exceptions
            // from the valid snapshot and continue
            // until we find a valid one
            try {
<span class="fc bfc" id="L163" title="All 2 branches covered.">                if (Util.isValidSnapshot(f)) {</span>
<span class="fc" id="L164">                    list.add(f);</span>
<span class="fc" id="L165">                    count++;</span>
<span class="fc bfc" id="L166" title="All 2 branches covered.">                    if (count == n) {</span>
<span class="fc" id="L167">                        break;</span>
                    }
                }
<span class="nc" id="L170">            } catch (IOException e) {</span>
<span class="nc" id="L171">                LOG.info(&quot;invalid snapshot &quot; + f, e);</span>
<span class="fc" id="L172">            }</span>
<span class="fc" id="L173">        }</span>
<span class="fc" id="L174">        return list;</span>
    }

    /**
     * find the last n snapshots. this does not have
     * any checks if the snapshot might be valid or not
     * @param the number of most recent snapshots 
     * @return the last n snapshots
     * @throws IOException
     */
    public List&lt;File&gt; findNRecentSnapshots(int n) throws IOException {
<span class="fc" id="L185">        List&lt;File&gt; files = Util.sortDataDir(snapDir.listFiles(), &quot;snapshot&quot;, false);</span>
<span class="fc" id="L186">        int i = 0;</span>
<span class="fc" id="L187">        List&lt;File&gt; list = new ArrayList&lt;File&gt;();</span>
<span class="pc bpc" id="L188" title="1 of 2 branches missed.">        for (File f: files) {</span>
<span class="fc bfc" id="L189" title="All 2 branches covered.">            if (i==n)</span>
<span class="fc" id="L190">                break;</span>
<span class="fc" id="L191">            i++;</span>
<span class="fc" id="L192">            list.add(f);</span>
<span class="fc" id="L193">        }</span>
<span class="fc" id="L194">        return list;</span>
    }

    /**
     * serialize the datatree and sessions
     * @param dt the datatree to be serialized
     * @param sessions the sessions to be serialized
     * @param oa the output archive to serialize into
     * @param header the header of this snapshot
     * @throws IOException
     */
    protected void serialize(DataTree dt,Map&lt;Long, Integer&gt; sessions,
            OutputArchive oa, FileHeader header) throws IOException {
        // this is really a programmatic error and not something that can
        // happen at runtime
<span class="pc bpc" id="L209" title="1 of 2 branches missed.">        if(header==null)</span>
<span class="nc" id="L210">            throw new IllegalStateException(</span>
                    &quot;Snapshot's not open for writing: uninitialized header&quot;);
<span class="fc" id="L212">        header.serialize(oa, &quot;fileheader&quot;);</span>
<span class="fc" id="L213">        SerializeUtils.serializeSnapshot(dt,oa,sessions);</span>
<span class="fc" id="L214">    }</span>

    /**
     * serialize the datatree and session into the file snapshot
     * @param dt the datatree to be serialized
     * @param sessions the sessions to be serialized
     * @param snapShot the file to store snapshot into
     */
    public synchronized void serialize(DataTree dt, Map&lt;Long, Integer&gt; sessions, File snapShot)
            throws IOException {
<span class="pc bpc" id="L224" title="1 of 2 branches missed.">        if (!close) {</span>
<span class="fc" id="L225">            OutputStream sessOS = new BufferedOutputStream(new FileOutputStream(snapShot));</span>
<span class="fc" id="L226">            CheckedOutputStream crcOut = new CheckedOutputStream(sessOS, new Adler32());</span>
            //CheckedOutputStream cout = new CheckedOutputStream()
<span class="fc" id="L228">            OutputArchive oa = BinaryOutputArchive.getArchive(crcOut);</span>
<span class="fc" id="L229">            FileHeader header = new FileHeader(SNAP_MAGIC, VERSION, dbId);</span>
<span class="fc" id="L230">            serialize(dt,sessions,oa, header);</span>
<span class="fc" id="L231">            long val = crcOut.getChecksum().getValue();</span>
<span class="fc" id="L232">            oa.writeLong(val, &quot;val&quot;);</span>
<span class="fc" id="L233">            oa.writeString(&quot;/&quot;, &quot;path&quot;);</span>
<span class="fc" id="L234">            sessOS.flush();</span>
<span class="fc" id="L235">            crcOut.close();</span>
<span class="fc" id="L236">            sessOS.close();</span>
        }
<span class="fc" id="L238">    }</span>

    /**
     * synchronized close just so that if serialize is in place
     * the close operation will block and will wait till serialize
     * is done and will set the close flag
     */
    @Override
    public synchronized void close() throws IOException {
<span class="fc" id="L247">        close = true;</span>
<span class="fc" id="L248">    }</span>

 }
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>